""" Vindby
    Copyright (C) 2018  Esther Dornhelm

    This program is licensed under an Attribution-NonCommercial 4.0 International (CC BY-NC 4.0) license

    Terms and conditions of this license if defined in
    file 'LICENSE.txt', which is part of this source code package.

    See <https://creativecommons.org/licenses/by-nc/4.0/>."""

class Cell:
    """Represents one cell in the sea grid"""

    def __init__(self):
        self.id=None
        self.xcoor=None
        self.ycoor=None
        self.area=None
        self.depthclass=None
        self.depth=None
        self.status=None
        self.meanU90=None
        self.meanH =None
        self.dist2shore=None
        self.env_protection=None
        self.shipping_channel=None
        self.soilqual=None
        self.wind_ampfactor=None
        self.myFarm=None

    def __init__(self,source,cellWeather):
        self.id=source['ID']
        self.name='Cell '+str(self.id)
        self.xcoor=source['x']
        self.ycoor=source['y']
        self.area=source['A']
        self.depthclass=source['d']
        self.depth=source['depth']
        self.status=source['status']
        self.cellWeather=cellWeather #add wind here when cell is created
        self.dist2shore=source['dist2shore']
        self.env_protection=source['env_protection']
        self.shipping_channel=source['shipping_channel']
        self.soilqual=source['soil']
        self.wind_ampfactor=source['wind_ampfactor']

        self.meanU90 = round(cellWeather.metOcean['meanwind']*self.wind_ampfactor,2)
        self.meanH =  round(cellWeather.metOcean['meanwave']*self.wind_ampfactor,2)

    def __str__(self):
        return ("Cell " + str(self.id) +" : Water depth "
                + str(int(self.depth))+"m ("+str(self.depthclass) +") Soil Quality "+str(self.soilqual)+" : Dist to shore: "
                + str(self.dist2shore) +"km : mean wind speed: " + str(self.meanU90)
                + "m/s : Environmental Restrictions "+str(self.env_protection)+" : Vessel route "+str(self.shipping_channel)
                + " : status: " + str(self.status))
