""" Vindby
    Copyright (C) 2018  Esther Dornhelm

    This program is licensed under an Attribution-NonCommercial 4.0 International (CC BY-NC 4.0) license

    Terms and conditions of this license are defined in
    file 'LICENSE.txt', which is part of this source code package.

    See <https://creativecommons.org/licenses/by-nc/4.0/>."""

import pandas

class Costs:
    """Represents the costs of things"""

    def __init__(self):
        self.costlist={}
        self.inflationRate = None

    def read(self):             #Import cost data
        cost_data = pandas.read_csv('tcosts.txt', header = None, sep='\t')
        for value in cost_data[1]:
            value=float(value)
        self.costlist = dict(zip(cost_data[0],cost_data[1]))
        self.inflationRate = self.costlist['RATE_inflation']

    def inflation(self):        #Apply inflation once a year
        for item, value in self.costlist.items():
            if 'RATE_' not in item and 'duration_' not in item:
                self.costlist[item] = value * (1 + self.inflationRate)

