""" Vindby
    Copyright (C) 2018  Esther Dornhelm

    This program is licensed under an Attribution-NonCommercial 4.0 International (CC BY-NC 4.0) license

    Terms and conditions of this license are defined in
    file 'LICENSE.txt', which is part of this source code package.

    See <https://creativecommons.org/licenses/by-nc/4.0/>."""

class OMoptions():
    """Represents all O & M options"""

    def __init__(self):
        self.strategyDescriptions={}
        self.strategyList=[] #redundantprogramming, leave for now because need to move forward with process.

    def displayOptions(self,costs,monitoring_success_rate):
        S=int(monitoring_success_rate*100)
        self.strategyList=['Corrective','Condition Based','Scheduled_Monthly']
        example_repair = 'turbine_Hub_Major_Repair'
        example_cost = int(costs[example_repair])
        example_cost_prevent = int(example_cost * costs['RATE_preventative_repair'])
        example_vessel = 'FSV'
        example_vessel_cost = int(costs['vessel_'+str(example_vessel)])
        self.strategyDescriptions={'Corrective Maintenance    ': 'Most failures are repaired when they occur (or saved for later in bad weather), minimizing downtime at higher repair costs. Cost for one average repair: \n '
                                                 '\t\t\t\t\t\t\tVessel Charter: {:,} (each repair)\n'
                                                 '\t\t\t\t\t\t\tRepair: {:,}'.format(example_vessel_cost,example_cost),
                                   'Condition Based Monitoring': 'Similar to corrective maintenance, but warnings about impending failures may be received and structure can be fixed before full blown failure at lower repair costs. Cost of an average repairs include:\n'
                                                                 '\t\t\t\t\t\t\tMonitoring System one time cost: {:,} ({}% success rate of predicting failures)\n'
                                                                 '\t\t\t\t\t\t\tVessel Charter: {:,} (each repair)\n'
                                                                 '\t\t\t\t\t\t\tPreventative Repair: {:,} \n'
                                                                 '\t\t\t\t\t\t\tRepair: {:,} (without warning)'.format(costs['ConditionBasedMaintenance_upfront'],S,example_vessel_cost,example_cost_prevent,example_cost),
                                   'Scheduled Monthly Repairs ': 'Inspection and maintenance vessels go out once a month to fix all repairs. Reduce costs of vessel charters, but with much more downtime. Cost for one monthly trip:\n'
                                                                 '\t\t\t\t\t\t\tVessel Charter: {:,} (for multiple repairs)\n'
                                                                 '\t\t\t\t\t\t\tRepair: {:,} '.format(example_vessel_cost,example_cost)}
        i = 1
        print('\nPossible maintenance strategies are:')
        for name, strategy in self.strategyDescriptions.items():
            print('\t({}) {}: {}'.format(i,name,strategy))
            i+=1

# x=OMoptions()
# x.displayOptions()
