""" Vindby
    Copyright (C) 2018  Esther Dornhelm

    This program is licensed under an Attribution-NonCommercial 4.0 International (CC BY-NC 4.0) license

    Terms and conditions of this license are defined in
    file 'LICENSE.txt', which is part of this source code package.

    See <https://creativecommons.org/licenses/by-nc/4.0/>."""

class RepairVessel:
    """Represents one repair vessel. Sadly it doesn't have any attributes of its own. It lives to only serves other classes."""

    def __init__(self): #,charterCost):
        self.busy=False

    def process(self, farmtorepair, repairloc, RepairType):
        if str(repairloc.__class__)=="<class 'mWindFarm.WindFarm'>":
            self.repairFarm(repairloc)
        elif str(repairloc.__class__)=="<class 'mTurbine.Turbine'>":
            self.repairTurbine(repairloc, farmtorepair, RepairType)
        elif str(repairloc.__class__)=="<class 'mSubstructure.Substructure'>":
            self.repairStructure(repairloc,farmtorepair, RepairType)
        elif str(repairloc.__class__)=="<class 'mCell.Cell'>":
            self.repairConstruction(farmtorepair)

    def repairTurbine(self, turbine, farmtorepair, RepairType):
        turbine.turbineFailure=None
        del farmtorepair.failures[turbine]
        if "Major_Replacement" in RepairType: #Once a component on the turbine has had a major replacement, it is assumed that it wont need another in its lifetime.
            turbine.myTurbineFailureRates[RepairType] = 0

    def repairStructure(self, structure, farmtorepair, RepairType):
        structure.structureFailure=None
        del farmtorepair.failures[structure]
        farmtorepair.myTurbineList[structure.id-1].notification.pop('autoshutdown',None) #turn turbine back on, if autoshutdown
        if RepairType == 'structure_bearing': #once bearing failure is repaired, it wont occur again at that structure
            structure.myStructureFailureRates[RepairType] = 0

    def repairFarm(self,farm):
        farm.farmFailure={}
        del farm.failures[farm]

    def repairConstruction(self,farm):
        farm.farmFailure = {} #Construction failure can happen more than once during construction
        print('\nConstruction moving forward!')
