""" Vindby
    Copyright (C) 2018  Esther Dornhelm

    This program is licensed under an Attribution-NonCommercial 4.0 International (CC BY-NC 4.0) license

    Terms and conditions of this license are defined in
    file 'LICENSE.txt', which is part of this source code package.

    See <https://creativecommons.org/licenses/by-nc/4.0/>."""

class Stakeholder:
    """"Represents one stakeholder"""

    def __init__(self):
        self.influence=0
        self.satisfaction=0
        self.events = {} #May be able to phase out
        self.eventCounter = 1

    def display(self):
        print('\tTotal {} brownie points: {}'.format(self,self.satisfaction))
        for event, impact in self.events.items():
            points = lambda i: ("+" if i > 0 else "") + str(i)
            print('\t\t' + event + ' ' + str(points(impact)))


class Government(Stakeholder):
    """Represents the government, which is a stakeholder"""
    def __init__(self):
        Stakeholder.__init__(self)
    def meeting(self,event_raw,effect):
        self.satisfaction += effect
        event = str(event_raw) + ' (' + str(effect) + ' brownie point each instance)'
        self.events[event] = effect*self.eventCounter
        self.eventCounter +=1

    def __str__(self):
        return 'Government'

class Public(Stakeholder):
    """Represents the government, which is a stakeholder"""
    def __init__(self):
        Stakeholder.__init__(self)
    def meeting(self,event_raw,effect):
        self.satisfaction += effect
        event = str(event_raw) + ' (' + str(effect) + ' brownie point each instance)'
        self.events[event] = effect*self.eventCounter
        self.eventCounter +=1

    def __str__(self):
        return 'Public'

class Shareholders(Stakeholder):
    """Represents the government, which is a stakeholder"""
    def __init__(self):
        Stakeholder.__init__(self)
    def meeting(self,event_raw,effect):
        self.satisfaction += effect
        event = str(event_raw) + ' (' + str(effect) + ' brownie point each instance)'
        self.events[event] = effect*self.eventCounter
        self.eventCounter +=1
    def __str__(self):
        return 'Shareholders'


