""" Vindby
    Copyright (C) 2018  Esther Dornhelm

    This program is licensed under an Attribution-NonCommercial 4.0 International (CC BY-NC 4.0) license

    Terms and conditions of this license are defined in
    file 'LICENSE.txt', which is part of this source code package.

    See <https://creativecommons.org/licenses/by-nc/4.0/>."""

import math
from mSubstructureAll import *

class SubstructureAvailable:
    """List of available support structures"""

    def __init__(self):
        self.substructureList=[]
        self.count=4#Number of available substructures that the game begins with
        self.unlock=0#Assign below - the number of substructures that can be unlocked.
        self.prices = {}

    def read(self):
        x=SubstructureAll()
        x.read()
        self.substructureList=[]
        self.unlock= len(x.substructureListAll) - self.count #Number of remaining substructure to be unlocked. At zero, game stops checking
        for i in range(0,self.count):
            self.substructureList.append(x.substructureListAll[i])
        self.count+=1

    def display(self, costs, depth, soil_quality):
        i=1
        print('Support Structures available are:')
        for structure in self.substructureList:
            cost1 = structure.priceQuote(costs, depth, soil_quality)
            cost = self.roundTo(cost1,100000)
            print('\t({}) {} (Cost: €{:,} each)'.format(i, structure.type, cost))
            i+=1

    def roundTo(self,value,nearest):
        return int(math.ceil(value / nearest)) * nearest



#x=SubstructureAvailable()
#x.read(4)
#x.display()
#print(x.turbineList[0].cap)
#y=x.grab(1)
#print(y)