""" Vindby
    Copyright (C) 2018  Esther Dornhelm

    This program is licensed under an Attribution-NonCommercial 4.0 International (CC BY-NC 4.0) license

    Terms and conditions of this license are defined in
    file 'LICENSE.txt', which is part of this source code package.

    See <https://creativecommons.org/licenses/by-nc/4.0/>."""

from mTurbineType import * #make sure file names of classes or modules are named differently from their classes, with an 'm' in front
from mPowerCurves import *

class TurbineAll:
    """Represents all possible turbines"""

    def __init__(self):
        self.turbineList=[]
        self.powerCurveList=[]

    def read(self):
        X=PowerCurves()
        X.read()
        self.powerCurveList=X.powerCurveList
        f = open('tturbines.txt', 'r')
        self.turbineList = []
        for line in f:
            line = line.strip()
            columns = line.split()
            source = {}
            source['cap'] = int(columns[0])
            curve = next((item for item in self.powerCurveList if item["RatedPower"] == source['cap']))
            x = TurbineType(source, curve)
            self.turbineList.append(x)
        f.close()

# x=TurbineAll()
# x.read()
#
# for t in x.turbineList:
#     print(t.cap)
#x.display()