""" Vindby
    Copyright (C) 2018  Esther Dornhelm

    This program is licensed under an Attribution-NonCommercial 4.0 International (CC BY-NC 4.0) license

    Terms and conditions of this license are defined in
    file 'LICENSE.txt', which is part of this source code package.

    See <https://creativecommons.org/licenses/by-nc/4.0/>."""

import math

class Wallet:
    '''Represents users available money'''

    def __init__(self):
        self.balance=0
        self.record={}
        self.profits=0 #This is actually revenue. needs to be changed
        self.investments=0
        self.initialInvestment = 0
        self.operatingCosts = 0
        self.capitalCosts = 0

    def checkbalance(self):
        return round(self.balance,2)

    def withdraw(self,amount,purpose):
        self.balance-=amount
        self.record[str(purpose)]=-amount
        self.investments+=amount
        if 'Repair of' in purpose or 'Maintenance' in purpose:
            self.operatingCosts += amount
        else: #in future - make sur eto take out fines
            self.capitalCosts += amount

    def deposit(self,amount,purpose):
        self.balance +=amount
        self.record[str(purpose)]=amount
        if 'Initial Deposit' not in purpose:
            self.profits+=amount
        elif 'Initial Deposit' in purpose:
            self.initialInvestment = amount

    def display(self):
        print('\nCurrent Balance: €{:,}'.format(self.roundTo(self.balance,1000)))

    def displayLedger(self):
        self.display()
        for item in self.record:
            if 'Energy revenue from ' not in item:
                print('\t €{:15,.0f} : {}'.format(self.roundTo(self.record[item],1000), item))

    def roundTo(self,value,nearest):
        return int(math.ceil(value / nearest)) * nearest


#x=Wallet()
#x.deposit(10000,'trial')
#x.display()
#x.displayLedger()